using Godot;
using System;

public class GridCursor : Sprite
{
    [Export]
    public NodePath Grid { get; set; }
    private WorldGrid _grid;

    public override void _Ready()
    {
        _grid = GetNode<WorldGrid>(Grid);
    }
    
    public override void _Input(InputEvent @event)
    {
        base._Input(@event);
        
        if (@event is InputEventMouseMotion mouseMoveEvent)
        {
            var pos = mouseMoveEvent.Position;
            _grid.GetGridPos(pos, out var x, out var y);
            var position = new Vector2(x + .5f, y + .5f) * _grid.CellSize;
            this.Position = position;
        }
        else if (@event is InputEventMouseButton mouseButtonEvent)
        {
            var pos = mouseButtonEvent.Position;
            _grid.GetGridPos(pos, out var x, out var y);
            GD.Print($"({x}, {y})");
        }
    }
}
